﻿using HealthMonitor.Util.Entities.HealthMonitor.Taos;
using IoTSharp.Data.Taos;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HealthMonitor.Core.Map.HealthMonitor.Taos
{
    public class HmBloodPressStatsIncMap : GenericEntityTypeConfiguration<HmBloodPressStatsInc>
    {
        public override void Configure(EntityTypeBuilder<HmBloodPressStatsInc> entity)
        {
            entity.HasKey(e => e.Ts)
           .HasName("PRIMARY");

            entity.ToTable("stb_hm_bloodpress_stats_inc");

            entity.Property(e => e.Ts)
                .HasColumnName("ts")
                .HasColumnType("timestamp");

            entity
                .Property(e => e.Serialno)
                .HasColumnName("serialno")
                .HasColumnType("NCHAR");
            //.HasConversion(typeof(string))
            //.HasCharSet("utf8");

            //.HasCollation("utf8_general_ci");


            entity
                .Property(e => e.BloodPressId)
                .HasColumnName("bloodpress_id")
                .HasColumnType("NCHAR");
            //.HasConversion(typeof(string))
            //.HasCharSet("utf8");

            

            entity
               .Property(e => e.MessageId)
               .HasColumnName("message_id")
               .HasColumnType("NCHAR");
               //.HasConversion(typeof(string))
               //.HasCharSet("utf8");

            entity
               .Property(e => e.SystolicValue)
               .HasColumnName("systolic_value")
               .HasColumnType("INT");

            entity
               .Property(e => e.SystolicRefValue)
               .HasColumnName("systolic_ref_value")
               .HasColumnType("INT");

            entity
               .Property(e => e.SystolicAvgValue)
               .HasColumnName("systolic_avg_value")
               .HasColumnType("FLOAT");

            entity
               .Property(e => e.SystolicMaxValue)
               .HasColumnName("systolic_max_value")
               .HasColumnType("INT");

            entity
               .Property(e => e.SystolicMinValue)
               .HasColumnName("systolic_min_value")
               .HasColumnType("INT");

            entity
               .Property(e => e.SystolicAvgOffset)
               .HasColumnName("systolic_avg_offset")
               .HasColumnType("FLOAT");

            entity
               .Property(e => e.SystolicIncValue)
               .HasColumnName("systolic_inc_value")
               .HasColumnType("INT");

            entity
               .Property(e => e.DiastolicValue)
               .HasColumnName("diastolic_value")
               .HasColumnType("INT");

            entity
               .Property(e => e.DiastolicRefValue)
               .HasColumnName("diastolic_ref_value")
               .HasColumnType("INT");

            entity
               .Property(e => e.DiastolicAvgValue)
               .HasColumnName("diastolic_avg_value")
               .HasColumnType("FLOAT");

            entity
               .Property(e => e.DiastolicMaxValue)
               .HasColumnName("diastolic_max_value")
               .HasColumnType("INT");

            entity
               .Property(e => e.DiastolicMinValue)
               .HasColumnName("diastolic_min_value")
               .HasColumnType("INT");

            entity
               .Property(e => e.DiastolicAvgOffset)
               .HasColumnName("diastolic_avg_offset")
               .HasColumnType("FLOAT");

            entity
               .Property(e => e.DiastolicIncValue)
               .HasColumnName("diastolic_inc_value")
               .HasColumnType("INT");

            entity
               .Property(e => e.Gender)
               .HasColumnName("gender")
               .HasColumnType("TINYINT");


            entity
               .Property(e => e.Age)
               .HasColumnName("age")
               .HasColumnType("INT");


            //entity
            //   .Property(e => e.Hypertension)
            //   .HasColumnName("hypertension");

            entity
               .Property(e => e.Height)
               .HasColumnName("height")
               .HasColumnType("FLOAT");

            entity
               .Property(e => e.Weight)
               .HasColumnName("weight")
               .HasColumnType("FLOAT");


            entity
               .Property(e => e.LastUpdate)
               .HasColumnName("last_update")
               .HasColumnType("timestamp");


            entity
               .Property(e => e.StatDuration)
               .HasColumnName("stat_duration")
               .HasColumnType("INT");

            entity
               .Property(e => e.StatStartTime)
               .HasColumnName("stat_start_time")
               .HasColumnType("timestamp");

            entity
               .Property(e => e.StatEndTime)
               .HasColumnName("stat_end_time")
               .HasColumnType("timestamp");

            entity
              .Property(e => e.Remark)
              .HasColumnName("remark")
              .HasColumnType("NCHAR");
             //  .HasConversion(typeof(string))
            //   .HasCharSet("utf8");

            entity
              .Property(e => e.TailNo)
              .HasColumnName("serial_tail_no")
              .HasColumnType("NCHAR");
             //  .HasConversion(typeof(string))
            //   .HasCharSet("utf8");
        }
    }
}
